;Draw 3d Angle Shape
(apply '(lambda (/ a b c legthk a90 a270 ip1 ip2 cp1 cp2
                   p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12)

   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Top of Angle at Heel: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Bottom of Angle at Toe: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] X Axis at Face of Angle: "))
      )
   )
   (setq legthk (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 3 SHP_DATA)))   ;Draw Mode
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq legdpth (- (nth 1 shp_data) legthk))
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1) (setq cp1 ip1 cp2 ip2))
         ((= b 2)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 1 SHP_DATA)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 1 SHP_DATA)))
            )
         )
         ((= b 3)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 6 shp_data)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 6 shp_data)))
            )
         )
      )
      (setq p1 (polar cp1 a90 (nth 2 shp_data))
            p4 (polar cp2 a90 (nth 2 shp_data))
            p2 cp1
            p3 cp2
            p10 (list (car p2) (cadr p2) (- (caddr p2) (nth 1 shp_data)))
            p11 (list (car p3) (cadr p3) (- (caddr p3) (nth 1 shp_data)))
            p9  (polar p10 a90 legthk)
            p12 (polar p11 a90 legthk)
            p5 (list (car p1) (cadr p1) (- (caddr p1) legthk))
            p8 (list (car p4) (cadr p4) (- (caddr p4) legthk))
            p6 (list (car p9)  (cadr p9)  (+ (caddr p9)  legdpth))
            p7 (list (car p12) (cadr p12) (+ (caddr p12) legdpth))
      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6
               p7  p8  p9  p10 p11 p12 ""
                1   2   3  4 ""
                2  10  11  3 ""
               10   9  12 11 ""
                9   6   7 12 ""
                5   8   7  6 ""
                1   4   8  5 ""

                2   1   5 -6 ""
                6   9  10 -2 ""

                7   8   4 -3 ""
                3  11  12 -7 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (getvar "blipmode") c (getvar "osmode"))
      (setvar "blipmode" 0)
      (setvar "osmode" 0)
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar '("blipmode" "osmode") (list a c))
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)
