;P Shape Cross Section

(apply '(lambda ( / a b r p1 lp)
   (setq a (getvar "blipmode"))
   (princ (strcat "\nDrawing Section of [" (nth 0 SHP_DATA) "]"))
   (while
      (setq p1
         (cond
            ((= STL_INPUT_MODE "stl_ia") (getpoint "\n[PICK] Top of Pipe point: "))
            ((= STL_INPUT_MODE "stl_ib") (getpoint "\n[PICK] Bottom of Pipe point: "))
            ((= STL_INPUT_MODE "stl_ic") (getpoint "\n[PICK] Center point: "))
            ((= STL_INPUT_MODE "stl_id") (getpoint "\n[PICK] Center point: "))
         )
      )
      (initget 1)
      (cond
         ((= STL_INPUT_MODE "stl_ia")
            (setq ang (getangle p1 "\nIndicate rotation direction: "))
            (if (and (> ang 0) (<= ang pi))
               (setq p1 (polar p1 (+ ang pi) (/ (nth 1 SHP_DATA) 2.0)))
               (setq p1 (polar p1 ang (/ (nth 1 SHP_DATA) 2.0)))
            )
         )
         ((= STL_INPUT_MODE "stl_ib")
            (setq ang (getangle p1 "\nIndicate rotation direction: "))
            (if (and (> ang 0) (<= ang pi))
               (setq p1 (polar p1 ang (/ (nth 1 SHP_DATA) 2.0)))
               (setq p1 (polar p1 (+ ang pi) (/ (nth 1 SHP_DATA) 2.0)))
            )
         )
         ((= STL_INPUT_MODE "stl_ic")
            (setq ang (getangle p1 "\nIndicate X Axis direction: "))
         )
         ((= STL_INPUT_MODE "stl_id")
            (setq ang (getangle p1 "\nIndicate Y Axis direction: "))
         )
      )
      (setq lp (polar p1 ang (/ (cadr SHP_DATA) 2.0)))
      (command ".undo" "g")
      (setvar "blipmode" 0)
      (setq r (getvar "osmode"))
      (setvar "osmode" 0)
      (stl_set_lyr "stl-cntr")
      (command ".line"
         (polar p1 (+ ang (* pi 0.5)) (+ (/ (cadr SHP_DATA) 2) 6.0))
         (polar p1 (+ ang (* pi 1.5)) (+ (/ (cadr SHP_DATA) 2) 6.0)) "")
      (command ".line"
         (polar p1 (+ ang pi) (+ (/ (cadr SHP_DATA) 2) 6.0))
         (polar p1 ang (+ (/ (cadr SHP_DATA) 2) 6.0)) "")
      (stl_set_lyr "stl-objt")
      (command ".circle" p1 "d" (caddr SHP_DATA))
      (setq b (ssadd (entlast)))
      (command ".circle" p1 "d" (cadr SHP_DATA))
      (setq b (ssadd (entlast) b))
      (if (= STL_HATCH_MODE "stl_ha")
         (progn
            (stl_set_lyr "stl-htch")
            (command ".hatch" "steel" 4.0 (angtos (+ ang (* 0.5 pi))) b "")
         )
      )
      (setvar "osmode" r)
      (setvar "blipmode" a)
      (command ".undo" "e")
      (princ (strcat "\nDraw Section of [" (nth 0 SHP_DATA) "] again"))
      (setvar "lastpoint" lp)
   )
   (setvar "blipmode" a)
)
'()
)