;Draw 3d C Shape
(apply '(lambda (/ a b c webthk halfdep webdpth a90 a270 ip1 ip2 cp1 cp2
                   p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16)
   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Heel at Top of Flange point: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Heel at Bottom of Flange point: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] Face of Web at X Axis: "))
      )
   )
   (setq webthk (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))   ;Draw Mode
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq halfdep (/ (nth 1 shp_data) 2.0)
            webdpth (- (nth 1 shp_data) (* 2.0 (nth 5 shp_data)))
      )
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1) (setq p1 ip1 p4 ip2))
         ((= b 2)
            (setq p1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 1 SHP_DATA)))
                  p4 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 1 SHP_DATA)))
            )
         )
         ((= b 3)
            (setq p1 (list (car ip1) (cadr ip1) (+ (caddr ip1) halfdep))
                  p4 (list (car ip2) (cadr ip2) (+ (caddr ip2) halfdep))
            )
         )
      )
      (setq p2 (polar p1 a90 (nth 3 shp_data))
            p5 (polar p1 a90 webthk)
            p3 (polar p4 a90 (nth 3 shp_data))
            p8 (polar p4 a90 webthk)
            p6 (list (car p2) (cadr p2) (- (caddr p2) (nth 6 shp_data)))
            p7 (list (car p3) (cadr p3) (- (caddr p3) (nth 6 shp_data)))
            p5 (list (car p5) (cadr p5) (- (caddr p5) (nth 5 shp_data)))
            p8 (list (car p8) (cadr p8) (- (caddr p8) (nth 5 shp_data)))
            p13 (list (car p1) (cadr p1) (- (caddr p1) (nth 1 shp_data)))
            p14 (list (car p2) (cadr p2) (- (caddr p2) (nth 1 shp_data)))
            p16 (list (car p4) (cadr p4) (- (caddr p4) (nth 1 shp_data)))
            p15 (list (car p3) (cadr p3) (- (caddr p3) (nth 1 shp_data)))
            p10 (list (car p14) (cadr p14) (+ (caddr p14) (nth 6 shp_data)))
            p11 (list (car p15) (cadr p15) (+ (caddr p15) (nth 6 shp_data)))
            p9  (list (car p5) (cadr p5) (- (caddr p5) webdpth))
            p12 (list (car p8) (cadr p8) (- (caddr p8) webdpth))
      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6  p7  p8
               p9  p10 p11 p12 p13 p14 p15 p16 ""
                1   4   3  2 ""
                2   3   7  6 ""
                6   7   8  5 ""
                5   8  12  9 ""
               10   9  12 11 ""
               10  11  15 14 ""
               14  15  16 13 ""
                1  13  16  4 ""

                1   2   6  -5 ""
                9  10  14 -13 ""
                5  -9  13  -1 ""

               16  15  11 -12 ""
                8   7   3  -4 ""
               12  -8   4 -16 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (getvar "blipmode") c (getvar "osmode"))
      (setvar "blipmode" 0)
      (setvar "osmode" 0)
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar '("blipmode" "osmode") (list a c))
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)
