;Draw 3d ST Shape
(apply '(lambda (/ a b c webthk halfflg halfweb webdpth a90 a270 ip1 ip2 cp1 cp2
                   p1 p2 p3 p4 p5 p6 p7 p8 p9 p10 p11 p12 p13 p14 p15 p16)
   (setvar "cmdecho" 0)
   (princ (strcat "\nDrawing 3d View of [" (nth 0 SHP_DATA) "]"))
   (setq ip1
      (cond
         ((= STL_INPUT_MODE "stl_ia") (setq b 1) (getpoint "\n[PICK] Center Top of Flange point: "))
         ((= STL_INPUT_MODE "stl_ib") (setq b 2) (getpoint "\n[PICK] Center Bottom of Stem point: "))
         ((= STL_INPUT_MODE "stl_ic") (setq b 3) (getpoint "\n[PICK] X Axis at Center of Stem: "))
      )
   )
   (setq webthk (if (= STL_DRAW_MODE "stl_db") 0.5 (nth 2 SHP_DATA)))   ;Draw Mode
   (while (setq ip2 (getpoint ip1 "\n[PICK] End point: "))
      (setq halfflg (/ (nth 3 shp_data) 2.0)
            halfweb (/ webthk 2.0)
            webdpth (- (nth 1 shp_data) (nth 5 shp_data))
      )
      (setq a90  (+ (angle ip1 ip2) (* pi 0.5))
            a270 (+ (angle ip1 ip2) (* pi 1.5))
      )
      (cond
         ((= b 1) (setq cp1 ip1 cp2 ip2))
         ((= b 2)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 1 SHP_DATA)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 1 SHP_DATA)))
            )
         )
         ((= b 3)
            (setq cp1 (list (car ip1) (cadr ip1) (+ (caddr ip1) (nth 6 shp_data)))
                  cp2 (list (car ip2) (cadr ip2) (+ (caddr ip2) (nth 6 shp_data)))
            )
         )
      )
      (setq p1 (polar cp1 a90 halfflg)
            p4 (polar cp2 a90 halfflg)
            p2 (polar cp1 a270 halfflg)
            p3 (polar cp2 a270 halfflg)
            p9  (polar cp1 a90 halfweb)
            p12 (polar cp2 a90 halfweb)
            p10 (polar cp1 a270 halfweb)
            p11 (polar cp2 a270 halfweb)
            p5 (list (car p1) (cadr p1) (- (caddr p1) (nth 7 shp_data)))
            p6 (list (car p2) (cadr p2) (- (caddr p2) (nth 7 shp_data)))
            p7 (list (car p3) (cadr p3) (- (caddr p3) (nth 7 shp_data)))
            p8 (list (car p4) (cadr p4) (- (caddr p4) (nth 7 shp_data)))
            p9  (list (car p9)  (cadr p9)  (- (caddr p9)  (nth 5 shp_data)))
            p10 (list (car p10) (cadr p10) (- (caddr p10) (nth 5 shp_data)))
            p11 (list (car p11) (cadr p11) (- (caddr p11) (nth 5 shp_data)))
            p12 (list (car p12) (cadr p12) (- (caddr p12) (nth 5 shp_data)))
            p13 (list (car p9)  (cadr p9)  (- (caddr p9)  webdpth))
            p14 (list (car p10) (cadr p10) (- (caddr p10) webdpth))
            p15 (list (car p11) (cadr p11) (- (caddr p11) webdpth))
            p16 (list (car p12) (cadr p12) (- (caddr p12) webdpth))
      )
      (setq shp_list
         (list p1  p2  p3  p4  p5  p6  p7  p8
               p9  p10 p11 p12 p13 p14 p15 p16 cp1 cp2 ""
                1   2   3  4 ""
                2   6   7  3 ""
                6  10  11  7 ""
               10  14  15 11 ""
               14  13  16 15 ""
               13   9  12 16 ""
                9   5   8 12 ""
                1   4   8  5 ""

               17 1 5 -9 ""
               10 6 2 -17 ""
               9 13 14 -10 ""
               -17 -9 -10 ""

               18 3 7 -11 ""
               12 8 4 -18 ""
               11 15 16 -12 ""
               -18 -12 -11 "" ""
         )
      )
      (stl_set_lyr "stl-objt")
      (setq a (getvar "blipmode") c (getvar "osmode"))
      (setvar "blipmode" 0)
      (setvar "osmode" 0)
      (command ".pface")
      (mapcar 'command shp_list)
      (mapcar 'setvar '("blipmode" "osmode") (list a c))
      (setq ip1 ip2)
      (setvar "lastpoint" ip2)
   )
   (princ)
)
'()
)
